pro h5_write_variable, file, varname, data, nocompress = nogzip

; check it the file is really written in HDF format
;
  if (not h5f_is_hdf5(file)) then begin
    print, 'This file is not in HDF5 format or does not exist!'
    stop
  endif

  sz = size(data, /dim)

; open a file
;
  fid = h5f_open(file, /write)

; open group 'variables'
;
  gid = h5g_open(fid, 'variables')

; prepare datatype and dataspace
;
  tid = h5t_idl_create(data)
  sid = h5s_create_simple(sz)

; create and write variable
;
  if (keyword_set(nogzip)) then begin
    did = h5d_create(gid, varname, tid, sid)
  endif else begin
    did = h5d_create(gid, varname, tid, sid, gzip = 9, chunk = sz)
  endelse
  h5d_write, did, data
  h5d_close, did

  h5s_close, sid
  h5t_close, tid

; close group 'variables'
;
  h5g_close, gid

; close a file
;
  h5f_close, fid
end
